//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
#property strict

#property indicator_separate_window
#property indicator_buffers 9
#property indicator_color1  clrSilver
#property indicator_color2  clrDeepSkyBlue
#property indicator_color3  clrSandyBrown
#property indicator_color4  clrSilver
#property indicator_color5  clrSilver
#property indicator_color6  clrDeepSkyBlue
#property indicator_color7  clrDeepSkyBlue
#property indicator_color8  clrSandyBrown
#property indicator_color9  clrSandyBrown
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2
#property indicator_width9  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};
enum enFilterWhat
{
   flt_prc,  // Filter the rsi
   flt_val,  // Filter the frama
   flt_both  // Filter both
};
enum colorOn
{
   clrOnSlope, // Color change on slope change
   clrOnZero,  // Color change on middle floating level cross
   clrOnLevel  // Color change on outer floaing level cross
};

extern int          RsiPeriod       = 14;         // RSI period
extern enPrices     RsiPrice        = pr_close;   // RSI price
extern int          FramaPeriod     = 14;         // Frama period
extern double       Filter          = 0;          // Filter to use for filtering (<=0 - no filtering)
extern int          FilterPeriod    = 0;          // Filter period (0<= use frama period)
extern enFilterWhat FilterOn        = flt_val;    // Apply filter to:
extern int          LevelPeriod     = 35;         // Floating levels period
extern double       LevelUp         = 90;         // Floating level up
extern double       LevelDown       = 10;         // Floating level down
extern colorOn      ColorChangeOn   = clrOnSlope; // Color change on: 
extern bool         alertsOn        = true;       // Turn alerts on?
extern bool         alertsOnCurrent = false;      // Alerts on current (still opened) bar?
extern bool         alertsMessage   = true;       // Alerts should display a message?
extern bool         alertsSound     = false;      // Alerts should play a sound?
extern bool         alertsEmail     = false;      // Alerts should send an email?
extern bool         alertsNotify    = false;      // Alerts should send notification?

double rsi[],frmBuffer[],frmBufferua[],frmBufferub[],frmBufferda[],frmBufferdb[],state[],prices[],flu[],fld[],flm[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,flm);
   SetIndexBuffer(1,flu);
   SetIndexBuffer(2,fld);
   SetIndexBuffer(3,rsi);
   SetIndexBuffer(4,frmBuffer);
   SetIndexBuffer(5,frmBufferua);
   SetIndexBuffer(6,frmBufferub);
   SetIndexBuffer(7,frmBufferda);
   SetIndexBuffer(8,frmBufferdb);
   SetIndexBuffer(9,state);
   SetIndexBuffer(10,prices);
   IndicatorShortName("Frama of rsi("+(string)FramaPeriod+","+(string)RsiPeriod+","+(string)Filter+")");         
   return(0);
}

int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0)   return(-1);
      if(counted_bars > 0)   counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //

   if (state[limit] == 1) CleanPoint(limit,frmBufferua,frmBufferub);
   if (state[limit] ==-1) CleanPoint(limit,frmBufferda,frmBufferdb);
      int    tperiod = FilterPeriod; if (tperiod<=0) tperiod = FramaPeriod;
      double pfilter = Filter;       if (FilterOn==flt_val) pfilter=0;
      double vfilter = Filter;       if (FilterOn==flt_prc) vfilter=0;
      for(int i = limit; i >= 0; i--) prices[i] = getPrice(RsiPrice,Open,Close,High,Low,i);
      for(int i = limit; i >= 0; i--)
      {
         rsi[i] = iFilter(iRSIOnArray(prices,0,RsiPeriod,i),pfilter,tperiod,i,0);
         frmBuffer[i]   = iFilter(iFrama(rsi[i],FramaPeriod,i),vfilter,tperiod,i,1);
         frmBufferda[i] = EMPTY_VALUE;
         frmBufferdb[i] = EMPTY_VALUE;
         double min = frmBuffer[ArrayMinimum(frmBuffer,LevelPeriod,i)];
         double max = frmBuffer[ArrayMaximum(frmBuffer,LevelPeriod,i)];
         double range = max-min;
               fld[i] = min+range*LevelDown/100.0;
               flm[i] = min+range*0.5;
               flu[i] = min+range*LevelUp/100.0;
         if (i<Bars-1) 
         {
            switch (ColorChangeOn)
            {
               case clrOnSlope: 
                  state[i] = state[i+1];
                  if (frmBuffer[i]>frmBuffer[i+1]) state[i] =  1;
                  if (frmBuffer[i]<frmBuffer[i+1]) state[i] = -1;
               break;
               case clrOnZero:
                  state[i] = 0;
                  if (frmBuffer[i]>flm[i]) state[i] =  1;
                  if (frmBuffer[i]<flm[i]) state[i] = -1;
               break;
               case clrOnLevel: 
                  state[i] = 0;
                     if (frmBuffer[i]>flu[i]) state[i] =  1;
                     if (frmBuffer[i]<fld[i]) state[i] = -1;
               break;
            }                                    
         }

         if (state[i]== 1) PlotPoint(i,frmBufferua,frmBufferub,frmBuffer);
         if (state[i]==-1) PlotPoint(i,frmBufferda,frmBufferdb,frmBuffer);
      }   
   manageAlerts();     
   return(0);      
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define framaInstances 1
double workFrama[][framaInstances*2];
double iFrama(double price, int fperiod, int i, int instanceNo=0)
{
   if (fperiod<=1) return(price);
   if (ArrayRange(workFrama,0)!=Bars) ArrayResize(workFrama,Bars); int r = Bars-i-1; instanceNo*=2;
   
   //
   //
   //
   //
   //
   
   workFrama[r][instanceNo+0] = price;
   if (r<1) workFrama[r][instanceNo+1] = price;
   else
   {      
      int halfPeriod = fperiod/2,k;
      double hh = workFrama[r][instanceNo+0],ll=workFrama[r][instanceNo+0];
      for (k=1; k<fperiod && (r-k)>=0; k++)
      {
         hh = MathMax(workFrama[r-k][instanceNo+0],hh);
         ll = MathMin(workFrama[r-k][instanceNo+0],ll);
      }         
      double n3 = (hh-ll)/(double)fperiod;
      
      //
      //
      //
      //
      //
      
      hh = ll = workFrama[r][instanceNo+0];
      for (k=1; k<halfPeriod && (r-k)>=0; k++)
      {
         hh = MathMax(workFrama[r-k][instanceNo+0],hh);
         ll = MathMin(workFrama[r-k][instanceNo+0],ll);
      }         
      double n1 = (hh-ll)/(double)halfPeriod;
      
      //
      //
      //
      //
      //
      
      hh = ll = workFrama[MathMax(r-halfPeriod,0)][instanceNo+0];
      for (k=halfPeriod+1; k<fperiod && (r-k)>=0; k++)
      {
         hh = MathMax(workFrama[r-k][instanceNo+0],hh);
         ll = MathMin(workFrama[r-k][instanceNo+0],ll);
      }         
      double n2 = (hh-ll)/(double)halfPeriod;
      
      //
      //
      //
      //
      //
      
      double dimen = 0;
            if ((n1+n2)>0 && n3>0) dimen = (MathLog(n1+n2)-MathLog(n3))/MathLog(2.0);
      double alpha = MathMin(MathMax(MathExp(-4.6*(dimen-1.0)),0.001),1.000);
      workFrama[r][instanceNo+1] = alpha*price+(1-alpha)*workFrama[r-1][instanceNo+1];
   }
   return(workFrama[r][instanceNo+1]);      
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define filterInstances 2
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int instanceNo=0)
{
   if (filter<=0) return(tprice);
   if (ArrayRange(workFil,0)!= Bars) ArrayResize(workFil,Bars); i = Bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (int k=0;  k<period && (i-k)>=0; k++) stddev += MathPow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = MathSqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if( MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
        return(workFil[i][instanceNo+_fprice]);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

#define priceInstances 1
double workHa[][priceInstances*4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=4; int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i];  second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (state[whichBar] != state[whichBar+1])
      {
         switch (ColorChangeOn)
         {
            case clrOnSlope:
               if (state[whichBar]== 1) doAlert(whichBar,"sloping  up");
               if (state[whichBar]==-1) doAlert(whichBar,"sloping down");
               break;
            case clrOnZero:
               if (state[whichBar]== 1) doAlert(whichBar,"crossing middle floating level up");
               if (state[whichBar]==-1) doAlert(whichBar,"crossing middle floating level down");
               break;
            case clrOnLevel:
               if (state[whichBar]== 1) doAlert(whichBar,"crossing upper floating level up");
               if (state[whichBar]==-1) doAlert(whichBar,"crossing lower floating level down");
               break;
         }    
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," frama of rsi ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" frama of rsi ",message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
